#!/usr/bin/env bash

sizes=(16 24 32 48 64 128 256 512 1024)
hidpi=(32 48 64 96 128 256 512 1024 2048)
numsize=8

mkdir -p resources/icons
rm resources/icons/*.png resources/icons.qrc

echo "<RCC>" > resources/icons.qrc
echo "<qresource prefix=\"/tycho\">" >> resources/icons.qrc

comp_icon() {
	f=$1
	i=$2
	sz=${sizes[${i}]}
	hz=${hidpi[${i}]}
	out=icons/$(basename -s .svg "${f}")_${sz}
	out_s=${out}.png
	out_h=${out}@2x.png
	echo "	<file>${out_s}</file>" >> resources/icons.qrc
	echo "	<file>${out_h}</file>" >> resources/icons.qrc
	out_s=resources/${out_s}
	out_h=resources/${out_h}
	echo "${out_s}"
	convert -background none "${f}" -resize "${sz}x${sz}" "${out_s}" &
	convert -background none "${f}" -resize "${hz}x${hz}" "${out_h}" &
	wait
	optipng -quiet -o5 "${out_s}" &
	optipng -quiet -o5 "${out_h}" &
}

for f in resources/mini/*.svg
do
	for i in $(seq 0 "${numsize}")
	do
		comp_icon "${f}" "${i}"
	done
done

echo "</qresource>" >> resources/icons.qrc
echo "</RCC>" >> resources/icons.qrc

## EOF
